/**************************************************************************************************
* CM3LayerItems Class
*
* @module CM3LayerItems
* @Copyright HSU, Jim Graham, 2019
**************************************************************************************************/
//**************************************************************************************************
// Constructor
//**************************************************************************************************
/*
* Constructor
* @public, @constructs
*/
function CM3LayerItems()
{
	CMLayer.call(this);
};

CM3LayerItems.prototype=Object.create(CMLayer.prototype); // inherit prototype functions from PanelBase()

CM3LayerItems.prototype.contructor=CM3LayerItems; // override the constructor to go to ours

//**************************************************************************************************
// Public CMItem Functions
//**************************************************************************************************
//CM3LayerItems.prototype.Layer_SetOGLObjectVisible=CMLayer.prototype.SetOGLObjectVisible;

CM3LayerItems.prototype.SetOGLObjectVisible=function(Flag)
{
	//if (this.GetVisible()!=Flag)
	{
	//	this.Layer_SetOGLObjectVisible(Flag);
		
		var NumChildren=this.GetNumChildren();
		
		for (var i=0;i<NumChildren;i++)
		{
			this.GetChild(i).SetOGLObjectVisible(Flag);
		}
	}
}

CM3LayerItems.prototype.Paint=function(TheView) 
{
	var NumChildren=this.GetNumChildren();
		
	for (var i=0;i<NumChildren;i++)
	{
		this.GetChild(i).Paint(TheView);
	}
}

//**************************************************************************************************
// Public CMLayer Functions
//**************************************************************************************************
CM3LayerItems.prototype.AddItemToPopup=function(ThePopupMenu,TheText,Type,Class)
{
	var PropertiesElement=document.createElement('div');
	PropertiesElement.setAttribute("id","CM_SettingsElementMenuItem");
	PropertiesElement.className="CM_LayerListPopupMenuItem";
	PropertiesElement.innerHTML=TheText;
	
	PropertiesElement.TheLayer=this;
	PropertiesElement.ThePopupMenu=ThePopupMenu;
	PropertiesElement.Type=Type;
	
	PropertiesElement.addEventListener('click', function(event)
	{
		this.ThePopupMenu.style.visibility= "hidden";
	
		var TheItem;
		
		if (this.Type!=null)
		{
			var TheItem=new CM3ItemBox(this.Type);
		}
		else
		{
			if (Class==CMItemOrigin) TheItem=new CMItemOrigin(this.TheLayer);
		}
		TheItem.SetSetting("Item","Status",CMItem.STATUS_EDITABLE);
		
		this.TheLayer.AddChild(TheItem);
		
		event.stopPropagation();
	});
	ThePopupMenu.appendChild(PropertiesElement);
}

CM3LayerItems.prototype.CMLayer_FillPopupMenu=CMLayer.prototype.FillPopupMenu;

CM3LayerItems.prototype.FillPopupMenu=function(ThePopupMenu)
{
	this.CMLayer_FillPopupMenu(ThePopupMenu);
	
	this.AddItemToPopup(ThePopupMenu,"Add Box...",CM3ItemBox.BOX);
	
	this.AddItemToPopup(ThePopupMenu,"Add Cylinder...",CM3ItemBox.CYLINDER);
	
	this.AddItemToPopup(ThePopupMenu,"Add Pyramid...",CM3ItemBox.PYRAMID);
	
	this.AddItemToPopup(ThePopupMenu,"Add Cone...",CM3ItemBox.CONE);
	
	this.AddItemToPopup(ThePopupMenu,"Add Sphere...",CM3ItemBox.SPHERE);
	
	if (typeof(CMItemOrigin)!="undefined")
	{
		this.AddItemToPopup(ThePopupMenu,"Add Origin...",null,CMItemOrigin);
	}
}

//**************************************************************************************************
// Public CM3LayerItems Functions
//**************************************************************************************************

